* RollerText 
* original routine by CBM61
* adaptation by VRS
* music by DOC FROG
* font ALPHAFLIGHT
	
	opt	c-,ow-,o+
	
* ----------------------------------- offset execlib
OpenLib	equ	-552
CloseLib	equ	-414	
Forbid	equ	-132
Permit	equ	-138
Disable	equ	-120
Enable	equ	-126
Supervisor	equ	-30

* ----------------------------------- offset gfxlib
LoadView	equ	-222
WaitBlit	equ	-228
WaitTOF	equ	-270
OwnBlit	equ	-456
DisownBlit	equ	-462

* ----------------------------------- offset customs
BLTCON0=$40		
BLTCON1=$42
BLTAFWM=$44
BLTALWM=$46
BLTCPTH=$48
BLTCPTL=$4A
BLTBPTH=$4C
BLTBPTL=$4E
BLTAPTH=$50
BLTAPTL=$52
BLTDPTH=$54
BLTDPTL=$56
BLTSIZE=$58
BLTCMOD=$60
BLTBMOD=$62
BLTAMOD=$64
BLTDMOD=$66
BLTCDAT=$70
BLTBDAT=$72
BLTADAT=$74
DMACONR=$2

* ------------------------------------ offset dmacon
D_init=$8200
D_priB=$400
D_Btpl=$100
D_Copp=$80
D_Blit=$40
D_sprt=$20
D_disk=$10
D_CON=D_init|D_copp|D_Btpl|D_Blit

* ------------------------------------- parametres modifiables
DOS=1	; 0=no dos	  1=dos
PT=1	; 0=playerPT  1=playerPT3

* -------------------------------------
	section	prog,code
	
Start:	movem.l	d0-d7/a0-a6,-(sp)
	
	movea.l	4.w,a6
	lea	GfxName(pc),a1
	moveq	#0,d0
	jsr	OpenLib(a6)
	tst.l	d0
	beq	NoGfx
	
	lea	GfxBase(pc),a0
	move.l	d0,(a0)
	move.l	d0,a6
	
	lea	OldView(pc),a0
	move.l	$22(a6),(a0)
	
	suba.l	a1,a1
	jsr	LoadView(a6)
	
	jsr	WaitTOF(a6)
	jsr	WaitTOF(a6)
	jsr	WaitBlit(a6)
	
	movea.l	4.w,a6
	jsr	Forbid(a6)
	jsr	Disable(a6)
	
	bsr	GetVBR
; my init	
	move.l	#Screen,d0
	lea	CLplan,a0
	moveq	#1,d1
	moveq	#0,d2
	bsr	Place_Plans

	bsr	InitData
	bsr	InitCop
; save	
 	bsr	InitZic	
	bsr	Init
	
* Main Program ------------------------------------------------------

Main	bsr	Vbl	
mouse	btst	#6,$bfe001
	bne.s	mouse
* restore -----------------------------------------------------------	
End	bsr	StopZic
	bsr	Restore
	
	movea.l	4.w,a6
	jsr	Enable(a6)
	jsr	Permit(a6)
	
	movea.l	GfxBase(pc),a6
	movea.l	OldView(pc),a1
	jsr	LoadView(a6)
	move.l	$26(a6),$dff080
	
	movea.l	a6,a1
	movea.l	4.w,a6
	jsr	CloseLib(a6)
	
NoGfx	movem.l	(sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts
* ---------------------------------------------	
Init:	lea	$dff000,a6
	lea	Dma(pc),a0
	move.w	2(a6),d0		save dma
	or.w	d0,(a0)+
	move.w	$1c(a6),d0		intena
	or.w	d0,(a0)+
	
	move.w	#$7fff,d0
	move.w	d0,$96(a6)
	move.w	d0,$9a(a6)
	move.w	d0,$9c(a6)
	
	movea.l	VBR(pc),a1
	move.l	$6c(a1),(a0)	int3
	
	lea	interrupt(pc),a0
	move.l	a0,$6c(a1)
	move.w	#$c020,$9a(a6)
	
	lea	newcopper,a0
	move.l	a0,$80(a6)
	move.w	#0,$88(a6)
	move.w	#D_con,$96(a6)
	
	rts
* ---------------------------------------------
Restore:	
	lea	$dff000,a6
	move.w	#$7fff,d0
	move.w	d0,$96(a6)
	move.w	d0,$9a(a6)
	move.w	d0,$9c(a6)
	
	lea	Dma(pc),a0
	movea.l	VBR(pc),a1
	move.l	4(a0),$6c(a1)
	move.w	2(a0),$9a(a6)
	move.w	(a0),$96(a6)
	
	rts
* --------------------------------------------
GetVBR:	movea.l	4.w,a6
	btst	#0,$129(a6)
	beq.s	.normal
	
	lea	SuperCode(pc),a5
	jsr	Supervisor(a6)
	
	lea	VBR(pc),a0
	move.l	d0,(a0)
.normal	rts
	CNOP	0,4
SuperCode:	dc.l	$4e7a0801	; movec Vbr,d0
	rte
* --------------------------------------------
Dma	dc.w	$8000
intena	dc.w	$c000
int3	dc.l	0
GfxBase	dc.l	0
OldView	dc.l	0
VBR	dc.l	0
GfxName	dc.b	'graphics.library',0
	even
* --------------------------------------------
interrupt:	movem.l	a0-a6/d0-d7,-(sp)

	lea	$dff000,a6	
	andi.w	#$20,$1e(a6)	interruption VBL
	beq.s	pasInt
	
	bsr	RollerText
	bsr	PlayZic

	move.w	#$0020,$dff09c	; ok ! interrupt finished	
pasInt	movem.l	(sp)+,a0-a6/d0-d7	
	rte	
* --------------------------------------------
Place_plans:		
	move.w	d0,6(a0)
	swap	d0			
	move.w 	d0,2(a0)
	swap	d0
	tst.w	d1
	beq.s	.fin
	add.l	d2,d0
	addq.l	#8,a0
	subq.w	#1,d1
	bra.s	place_plans
.fin	rts
* -------------------------------------------
Vbl:	btst	#0,5(a6)
	beq.s	Vbl
.vbl	btst	#0,5(a6)
	bne.s	.vbl
	rts
* -------------------------------------------
;initpal:	lea	Logo+W*H*D,a0
;	lea	couleurs,a1
;	move.w	#$180,d0
;	moveq	#C-1,d1
;.loop	move.w	d0,(a1)+
;	move.w	(a0)+,(a1)+
;	addq.w	#2,d0
;	dbf	d1,.loop
;	rts
* --------------------------------------------
waitblitter	btst	#6,$dff002
	bne.s	waitblitter
	rts
* --------------------------------------------------------
InitCop	lea	listwait,a0
	move.w	#$800f,d1
	lea	Screen,a1
	move.l	a1,d3
	move.l	d3,d4
	addi.l	#54*6,d3	; premiere ligne
	addi.l	#54*73,d4	; derniere ligne
	lea	TabLigFront(pc),a1
	lea	TabLigBack(pc),a5
	moveq	#49,d7
.loop	move.w	d1,(a0)+		; wait
	move.w	#$fffe,(a0)+
	
	move.w	#$e2,(a0)+		; $e2,xxxx
	move.w	d3,(a0)+
	swap	d3
	move.w	#$e0,(a0)+
	move.w	d3,(a0)+
	swap	d3
	
	move.w	#$e6,(a0)+		; $e6,xxxx
	move.w	d4,(a0)+
	swap	d4
	move.w	#$e4,(a0)+
	move.w	d4,(a0)+
	swap	d4
		
	addi.w	#$100,d1		; next wait
	add.w	(a1)+,d3		; next ligne
	sub.w	-(a5),d4		; prec ligne
	dbf	d7,.loop
	rts
* --------------------------------------------------------
InitData	
	lea	TabLigFront(pc),a0
	moveq	#0,d0
	moveq	#49,d7
.loop	move.w	(a0),d0
	mulu	#54,d0
	move.w	d0,(a0)+
	dbf	d7,.loop
	rts
* --------------------------------------------------------
CharTxt		equ	0
SourceDec	equ	4
DestDec		equ	8
SourceRol	equ	12
DestRol		equ	16
AdScroll	equ	20
AdFont		equ	24
PText		equ	28
CptChar		equ	30
* ----------- vitesse scrolltext
bltCon	=	$d9f0		; bltcon0 -> vitesse ($f9f0)
Npix	=	12		; Nb pix avant new lettre (36)
* -----------
RollerText	lea	$dff000,a6
	btst	#10,$16(a6)
	bne.s	Roller
	rts
Roller	lea	Vars(pc),a3
	bsr	waitblitter
	move.l	#-1,BltAfwm(a6)
	move.w	#0,BltCon1(a6)
	
	addq.b	#1,CptChar(a3)
	cmpi.b	#Npix,CptChar(a3)
	beq.s	NewChar
	bra.s	Scroll
NewChar	clr.b	CptChar(a3)
	lea	TableChar(pc),a4
	lea	Text(pc),a2
	add.w	PText(a3),a2
	move.l	AdFont(a3),a0
	addq.w	#1,PText(a3)
	cmpi.w	#LenText,PText(a3)
	bne.s	pasencore
	clr.w	PText(a3)
pasencore	moveq	#0,d0
	move.b	(a2),d1
	lea	ListeChar(pc),a1
search	move.b	(a1),d2
	cmp.b	d1,d2
	beq.s	found
	addq.b	#1,d0
	lea	1(a1),a1
	bra.s	search
found	lsl.w	#1,d0
	add.w	d0,a4
	add.w	(a4),a0
	
BlitChar	bsr	waitblitter
	move.l	a0,BltApth(a6)
	move.l	CharTxt(a3),BltDpth(a6)
	move.l	#$240032,BltAmod(a6)
	move.w	#$9f0,BltCon0(a6)
	move.w	#30*64+2,BltSize(a6)
	
* ------- avance le scroll de 2 pixels	
Scroll	bsr	waitblitter
	move.l	SourceDec(a3),BltApth(a6)	; 4 = screen+4
	move.l	DestDec(a3),BltDpth(a6)		; 8 = screen+2
	move.l	#$20002,BltAmod(a6)
	move.w	#BltCon,BltCon0(a6)
	move.w	#75*64+26,BltSize(a6)

* ------- decale une ligne vers le haut	: scroll vertical
RollUp	bsr	waitblitter
	move.l	SourceRol(a3),BltApth(a6)	; 12 screen+54+2 source
	move.l	DestDec(a3),BltDpth(a6)		; 8 screen+2 dest
	move.l	#$60006,BltAmod(a6)
	move.w	#$9f0,BltCon0(a6)
	move.w	#74*64+24,BltSize(a6)

* ------- la ligne qui sort en haut de l'ecran revient en bas
RollDown	bsr	waitblitter
	move.l	AdScroll(a3),BltApth(a6)	; 20 screen
	move.l	DestRol(a3),BltDpth(a6)		; 16 screen+54*74 (54*78)	
	move.l	#0,BltAmod(a6)
	move.w	#1*64+27,BltSize(a6)
	rts
* --------------------------------------------------------
	ifeq	PT
	 include	"playerpt.s"
	elseif
	 include	"PT-Play_2.1a.s"
	endc

Vars	dc.l	Screen+54*40-4	; ad new char			; 0
	dc.l	Screen+4	; ad source scroll 2 pix horiz	; 4
	dc.l	Screen+2	; ad dest scroll horiz & vert.	; 8
	dc.l	Screen+54+2	; ad source decal. vertical	; 12
	dc.l	Screen+54*74	; ad dest decal. vertical	; 16
	dc.l	Screen		; ad screen scroll		; 20
	dc.l	Font		; ad font
	dc.w	0		; Ptext
	dc.b	0		; CptChar
	even
ListeChar	dc.b	'abcdefghijklmnopqrstuvwxyz0123456789"'
	dc.b	"':;(/),.-?!* "
	even
F1=40*33
F2=F1+40*33
F3=F2+40*33
F4=F3+40*33
TableChar	dc.w	0,4,8,12,16,20,24,28,32,36
	dc.w	F1+0,F1+4,F1+8,F1+12,F1+16,F1+20,F1+24,F1+28,F1+32,F1+36
	dc.w	F2+0,F2+4,F2+8,F2+12,F2+16,F2+20,F2+24,F2+28,F2+32,F2+36
	dc.w	F3+0,F3+4,F3+8,F3+12,F3+16,F3+20,F3+24,F3+28,F3+32,F3+36
	dc.w	F4+0,F4+4,F4+8,F4+12,F4+16,F4+20,F4+24,F4+28,F4+32,F4+36
Text	dc.b	'hello everybody '
	dc.b	'this is a little intro '
	dc.b	'for my first slideshow. date today ! 17-08-91 !........credits for this simply intro.......'
	dc.b	'code - varso ---- music composed by - doc frog ---- '
	dc.b	'font by - alphaflight  '
	dc.b	'this intro was coded with  devpac 2   .....'
	dc.b	' greetings to all our friends and especially to'
	dc.b	' original suppliers --- defeat - for the great musakcompil  zisc --- '
	dc.b	'cbm 61 - for this little roller scroll routine --- doc frog --- luc --- didi '
	dc.b	'  test restart                        '
LenText	equ	*-Text
	even
* ---------- lignes endroit
TabLigFront	dc.w	3,2,2,2,1,2,1,1,2
	dcb.w	30,1
	dc.w	2,1,2,1,2,2,2,3,5
TabLigBack	dc.w	1,1
* ---------------------------------------------------------- COPPERLIST
	section	copper,data_c	
Newcopper:   
	DC.W 	$008E,$8041,$0090,$30d1
	DC.W 	$0092,$0018,$0094,$00d8
	DC.W 	$100,$2200,$102,0,$104,0
; Sprites	
	DC.W	$120,0,$122,0
	dc.w	$124,0,$126,0
	dc.w	$128,0,$12a,0
	dc.w	$12c,0,$12e,0
	dc.w	$130,0,$132,0
	dc.w	$134,0,$136,0
	dc.w	$138,0,$13a,0
	dc.w	$13c,0,$13e,0
; Modulos 
	dc.w 	$10a,4,$108,4
		
CLplan	dc.w	$e0,0,$e2,0
	dc.w	$e4,0,$e6,0

	dc.w	$180,0
	dc.w	$182,$999
	dc.w	$184,$999
	dc.w	$186,$ddd
	
listwait	ds.w	10*50
	dc.w	$100,0
	DC.L 	$FFFFFFFE ;FIN LISTE COPPER
* -----------------------------------------------------
Module:
mt_data	incbin	"mod.aquatiqua2"

Font	incbin	"alphafont.rw"

	section	ecran,bss_c
Screen	ds.b	54*78
	END
